//+------------------------------------------------------------------+
//|                                                        DSATR.mq4 |
//+------------------------------------------------------------------+

#property copyright "Copyright  2011, TheXpert"
#property link      "theforexpert@gmail.com"

extern int     ATRPeriod = 14;
extern int     SmoothPeriod = 20;

#property indicator_separate_window

#property indicator_buffers 2

#property indicator_color1 Red
#property indicator_width1 2

#property indicator_color2 White

double ATR[];
double AvgATR[];

int init()
{
   SetIndexBuffer(0, AvgATR);
   SetIndexBuffer(1, ATR);
   
   SetIndexBuffer(0, "Smoothed ATR");
   SetIndexLabel(1, "ATR");

   return(0);
}

int start()
{
   int toCount = Bars - IndicatorCounted();
   
   for (int i = toCount - 1; i >= 0; i--)
   {
      ATR[i] = iATR(Symbol(), 0, ATRPeriod, i);
   }
   
   for (i = toCount - 1; i >= 0; i--)
   {
      double sum = 0;
      AvgATR[i] = ATR[i];
      int dayShift = iBarShift(Symbol(), PERIOD_D1, Time[i], true);
      
      if (dayShift != -1)
      {
         int offset = Time[i] - iTime(Symbol(), PERIOD_D1, dayShift);
         double lastValue = ATR[i];
         
         for (int j = 0; j < SmoothPeriod; j++)
         {
            int elementShift = iBarShift(Symbol(), 0, iTime(Symbol(), PERIOD_D1, dayShift + j) + offset, true);
            if (elementShift == -1)
            {
               sum += lastValue;
            }
            else
            {
               sum += ATR[elementShift];
            }
         }
         AvgATR[i] = sum/SmoothPeriod;
      }
   }
   return(0);
}